package solutions.reslate.entertainment.spigotresourcesync;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;


public class CommandController implements CommandExecutor {
    private Set<String> names;
    private Map<String, Command> commands;


    public CommandController() {
        super();
        names = new HashSet<>();
        names.add("resourcesync");
        names.add("ressync");
        commands = new HashMap<>();
    }

    public void registerCommand(Command command) {
        if (command == null) throw new IllegalArgumentException("Command cannot be null!");
        this.commands.put(command.getName(), command);
        for (String alias : command.getAliases()) {
            this.commands.put(alias, command);
        }
    }

    public void deregisterCommand(Command command) {
        this.deregisterCommand(command.getName());
    }

    public void deregisterCommand(String commandName) {
        if (commandName == null || commandName.isBlank()) throw new IllegalArgumentException("Command name cannot be null or blank.");
        Command removed = this.commands.remove(commandName);
        for (String alias : removed.getAliases()) {
            this.commands.remove(alias);
        }
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (args.length == 0) return false;
        if (commands.containsKey(args[0])) {
            Command subcommand = commands.get(args[0]);
            return subcommand.execute(sender, label, Arrays.copyOfRange(args, 1, args.length));
        }
        return false;
    }
    
}
