package solutions.reslate.entertainment.spigotresourcesync.commands;

import java.util.ArrayList;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;

import solutions.reslate.entertainment.spigotresourcesync.SyncListManager;

public class SyncCommand extends Command {
    private SyncListManager syncListManager;


    public SyncCommand(SyncListManager syncListManager) {
        super(
            "sync",
            "Synchronise based off your configurations.",
            "sync [sync group name]",
            new ArrayList<>()
        );
        this.syncListManager = syncListManager;
    }

    @Override
    public boolean execute(CommandSender sender, String commandLabel, String[] args) {
        if (args.length > 1) return false;
        if (args.length == 1) {
            String groupName = args[0];
            syncListManager.synchroniseGroupSyncList(groupName);
            sender.sendMessage(String.format("Synchronisation of \"%s\" complete!", groupName));
        } else {
            syncListManager.synchroniseAllSyncList();
            sender.sendMessage("Synchronisation of all items complete!");
        }
        return true;
    }
    
}
