package solutions.reslate.entertainment.spigotresourcesync.data;

import java.io.Serializable;
import java.util.Objects;

public class SyncPair implements Serializable {
    private String source;
    private String destination;

    public SyncPair(String source, String destination) {
        super();
        this.source = source;
        this.destination = destination;
    }

    public SyncPair() {
        super();
    }

    public void setSource(String source) {
        this.source = source;
    }

    public void setDestination(String destination) {
        this.destination = destination;
    }

    public String getSource() {
        return source;
    }

    public String getDestination() {
        return destination;
    }

    @Override
    public int hashCode() {
        return Objects.hash(this.source, this.destination);
    }

    @Override
    public boolean equals(Object obj) {
        if (getClass() != obj.getClass()) {
            return false;
        }
        SyncPair syncPair = (SyncPair) obj;
        return this.source.equals(syncPair.source) 
                && this.destination.equals(syncPair.destination);
    }

    @Override
    public String toString() {
        return String.format("(%s, %s)", this.source, this.destination);
    }
}
