package solutions.reslate.entertainment.spigotresourcesync;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assumptions.assumeTrue;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Logger;

import org.junit.jupiter.api.Test;

import solutions.reslate.entertainment.spigotresourcesync.data.Configuration;
import solutions.reslate.entertainment.spigotresourcesync.data.SyncPair;
import solutions.reslate.entertainment.spigotresourcesync.serialisation.JacksonYamlSerialiser;
import solutions.reslate.entertainment.spigotresourcesync.serialisation.Serialiser;

public class TestConfigManager {
    @Test
    void persistConfiguration() throws IOException {
        File dummyConfig = File.createTempFile("dummy_config", ".yml");
        Serialiser<Configuration> dummySerialiser = new JacksonYamlSerialiser<>();
        Logger logger = Logger.getLogger(this.getClass().getName());
        ConfigManager initialConfigManager = new ConfigManager(dummyConfig, dummySerialiser, logger);
        SyncPair dummySyncPair = new SyncPair("abc", "def");
        initialConfigManager.getConfiguration().getSyncList().addSynchronisationPair(dummySyncPair, "a");
        initialConfigManager.flush();
        assumeTrue(dummyConfig.exists());
        ConfigManager finalConfigManager = new ConfigManager(dummyConfig, dummySerialiser, logger);
        finalConfigManager.load();
        assertEquals(dummySyncPair, new ArrayList<>(finalConfigManager.getConfiguration().getSyncList().gatherAllSyncPairs()).get(1));
    }
}
