package solutions.reslate.entertainment.spigotresourcesync.synchroniser;

import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;

import org.junit.jupiter.api.Test;

import solutions.reslate.entertainment.spigotresourcesync.synchronisation.ApacheCommonsIOSynchroniser;

public class TestApacheCommonsIOSynchroniser {
    @Test
    void testDir2DirSync() throws IOException {
        ApacheCommonsIOSynchroniser dummySynchroniser = new ApacheCommonsIOSynchroniser();
        File dummyDirA = Files.createTempDirectory("dir_A").toFile();
        File dummyDirB = Files.createTempDirectory("dir_B").toFile();
        File dummyFileA = File.createTempFile("file_A", ".txt", dummyDirA);
        dummySynchroniser.sync(dummyDirA, dummyDirB);
        assertTrue(new File(dummyDirB, dummyFileA.getName()).exists());
    }

    @Test
    void testFile2DirSync() throws IOException {
        ApacheCommonsIOSynchroniser dummySynchroniser = new ApacheCommonsIOSynchroniser();
        File dummyDirA = Files.createTempDirectory("dir_A").toFile();
        File dummyDirB = Files.createTempDirectory("dir_B").toFile();
        File dummyFileA = File.createTempFile("file_A", ".txt", dummyDirA);
        dummySynchroniser.sync(dummyFileA, dummyDirB);
        assertTrue(new File(dummyDirB, dummyFileA.getName()).exists());
    }

    @Test
    void testFile2FileSync() throws IOException {
        ApacheCommonsIOSynchroniser dummySynchroniser = new ApacheCommonsIOSynchroniser();
        File dummyDirA = Files.createTempDirectory("dir_A").toFile();
        File dummyDirB = Files.createTempDirectory("dir_B").toFile();
        File dummyFileA = File.createTempFile("file_A", ".txt", dummyDirA);
        File dummyFileB = new File(dummyDirB, "file_B");
        dummySynchroniser.sync(dummyFileA, dummyFileB);
        assertTrue(dummyFileB.exists());
    }
}
